/*
  Tutanchamun, an arcade game
  Copyright (C) 1998  David Kastrup
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
#include "tutan.h"
#include "tutdisp.h"
#include "tutsound.h"

int adddig(char *digit, int value)
{
  int carry = 0;

  value += *digit == ' ' ? 0 : *digit - '0';
  if (value == 0)
    return 0;
  while (value > 9) {
    value -= 10;
    ++carry;
  }
  *digit = '0' + value;
  return carry;
}

void dspsco()
{
  d_wrscore(player, playfield[player].score);
}

void add100(int i)
{
  int d;

  if (demflg)
    return;
  if (playfield[player].score[4] == ' ')
    playfield[player].score[4] = '0';
  for (d=3; i!=0 && d>=0; d--) {
    i = adddig(&playfield[player].score[d], i);
    if (d == 1) {
      if (!((playfield[player].score[1]-'0')&1)) {
	sndfrs();
	d_drasma(playfield[player].smarts++, lampshd);
      } else if (playfield[player].score[1] == '3'
		 && playfield[player].score[0] == ' ') {
	sndfrm();
	music();
	d_draman(playfield[player].men++, manshd);
      }
    }
  }
  dspsco();
}
  
void add10(int i)
{
  if (demflg)
    return;
  add100(adddig(&playfield[player].score[4],i));
}

